#include "Board2D.hpp"

const Board2D::Coords Board2D::InvalidCoords = Coords();

Board2D::Board2D(unsigned int columnNumber, unsigned int lineNumber)
    :m_board(columnNumber,std::vector<Piece>(lineNumber))
{

}

void Board2D::init(const std::vector<std::pair<Coords, Piece> >& startPieces)
{
    std::vector<std::pair<Coords, Piece> >::const_iterator itPiece = startPieces.begin();
    for( ; itPiece != startPieces.end() ; ++itPiece )
    {
        if ( itPiece->first.isValid() )
        {
            m_board[itPiece->first.column][itPiece->first.line] = itPiece->second;
        }
    }
}

const Piece& Board2D::get(const int indexes[2])const
{
    return get(Coords(indexes));
}

const Piece& Board2D::get(const Coords& coords)const
{
    if ( coords.isValid() )
    {
        return m_board[coords.column][coords.line];
    }
    else
    {
        return SPiece::InvalidPiece;
    }
}

const std::vector<std::pair<Board2D::Coords, Piece> > Board2D::getPieces()const
{
    std::vector<std::pair<Coords, Piece> >  pieces;

    int coords[2] = {0};

    for ( int column = 0 ; column < getDimensionLength(0) ; column++ )
    {
        for ( int line = 0 ; line < getDimensionLength(1) ; line++ )
        {
            coords[0] = column;
            coords[1] = line;

            Piece p = get(coords);
            if ( p.isValid() )
            {
                pieces.push_back(std::pair<Coords, Piece>(Coords(coords),p));
            }
        }
    }

    return pieces;
}
