#ifndef NEWGAMEDIALOG_HPP
#define NEWGAMEDIALOG_HPP

#include <QDialog>

class QComboBox;

namespace Ui {
    class NewGameDialog;
}

class NewGameDialog : public QDialog
{
private:

    Ui::NewGameDialog* m_pUI;   /*!< */

    /*! \brief Fills combobox \a pCombo with controlers name
     *  \param pCombo
     */
    void fillComboControler(QComboBox* pCombo);

public:
    /*!
        \param parent
     */
    explicit NewGameDialog(QWidget* parent);

    /*!
     */
    ~NewGameDialog();

    /*! \brief Returns the selected game type
     *  \param return
     */
    int getGameType()const;

    /*! \brief Returns the selected controlers ID
     *  \return
     */
    std::vector<int> getControlerTypes()const;

private slots:
    /*! \brief Reloads the UI for the controls
     *  Depending of the \a gameType, some controls will
     *  be added or removed
     *  \param gameType the game type actually selected
     */
    void reloadGameControls(int gameType);
};

/*! \class NewGameDialog NewGameDialog.hpp UI/NewGameDialog.hpp
 *  \brief Interface to create a new game
 *
 *  The interface dynamically updates following the game type choosed.
 *  It displays one combobox for the game type and some for the controlers
 *  (the number relies of the number returned by the game type)
 *  The game type can be known using getGameType() and the controlers type with
 *  getControlerTypes().
 *  \sa GameFactory
 */

#endif
