#include "PromotionDialog.hpp"
#include "ui_PromotionDialog.h"

#include <cassert>

PromotionDialog::PromotionDialog(int color, QWidget *parent) :
    QDialog(parent),m_pUI(new Ui::PromotionDialog)
{
    m_pUI->setupUi(this);

    QLabel* label_2 = new QLabel(m_pUI->horizontalLayoutWidget);
    QLabel* label_4 = new QLabel(m_pUI->horizontalLayoutWidget);
    QLabel* label_8 = new QLabel(m_pUI->horizontalLayoutWidget);
    QLabel* label_5 = new QLabel(m_pUI->horizontalLayoutWidget);


    label_2->setObjectName(QString::fromUtf8("label_2"));
    label_4->setObjectName(QString::fromUtf8("label_4"));
    label_8->setObjectName(QString::fromUtf8("label_8"));
    label_5->setObjectName(QString::fromUtf8("label_5"));

    if ( color == 0 )
    {
        label_2->setPixmap(QPixmap(QString::fromUtf8(":/pieces/wbishop.svg")));
        label_4->setPixmap(QPixmap(QString::fromUtf8(":/pieces/wknight.svg")));
        label_8->setPixmap(QPixmap(QString::fromUtf8(":/pieces/wrook.svg")));
        label_5->setPixmap(QPixmap(QString::fromUtf8(":/pieces/wqueen.svg")));
    }
    else
    {
        label_2->setPixmap(QPixmap(QString::fromUtf8(":/pieces/bbishop.svg")));
        label_4->setPixmap(QPixmap(QString::fromUtf8(":/pieces/bknight.svg")));
        label_8->setPixmap(QPixmap(QString::fromUtf8(":/pieces/brook.svg")));
        label_5->setPixmap(QPixmap(QString::fromUtf8(":/pieces/bqueen.svg")));
    }


    label_2->setAlignment(Qt::AlignCenter);
    label_4->setAlignment(Qt::AlignCenter);
    label_8->setAlignment(Qt::AlignCenter);
    label_5->setAlignment(Qt::AlignCenter);


    m_pUI->verticalLayout->insertWidget(0,label_2);
    m_pUI->verticalLayout_2->insertWidget(0,label_4);
    m_pUI->verticalLayout_4->insertWidget(0,label_8);
    m_pUI->verticalLayout_3->insertWidget(0,label_5);
}

PromotionDialog::~PromotionDialog()
{
    delete m_pUI;
}

char PromotionDialog::getChoice()const
{
    if ( m_pUI->bishopButton->isChecked() )
    {
        return 'b';
    }
    if ( m_pUI->rookButton->isChecked() )
    {
        return 'r';
    }
    if ( m_pUI->knightButton->isChecked() )
    {
        return 'n';
    }
    if ( m_pUI->queenButton->isChecked() )
    {
        return 'q';
    }

    assert(false);
}
