#ifndef LISTENER_HPP
#define LISTENER_HPP

template<typename MessageType>
class Listener
{
private:

public:
    /*!
     */
    virtual ~Listener() {}

    /*! function called with the message to be passed
     *  \param message
     */
    virtual void notify(const MessageType& message)=0;
};

/*! \class Listener Listener.hpp Utils/Listener.hpp
 *  \brief Listener base for Listener/Notifier design pattern
 *
 *  The listener is the instance called when a new event arrived to the notifier
 *  in a Listener / notifier design pattern
 */

#endif
