#include <QtGui/QApplication>

#include <Game/Game.hpp>
#include <Game/Boards/ChessBoard.hpp>
#include <Game/Rules/ChessRules.hpp>
#include <Controlers/KeyboardControler.hpp>
#include <Controlers/GNUChessControler.hpp>
#include <Controlers/QtGNUChessControler.hpp>

#include <Renderers/Renderer.hpp>
#include <Renderers/ConsoleDisplay.hpp>

#include <Utils/Notifier.hpp>
#include <Utils/Listener.hpp>

/*
int main(int argc, char *argv[])
{
    Notifier<Move<ChessBoard::Coords>  > gameNotifier;
    Notifier<Move<ChessBoard::Coords> > statusNotifier;

    Game<ChessBoard, ChessRules> g(&gameNotifier,&statusNotifier);
    //Controler<ChessBoard>* pKC1 = new KeyboardControler();
    GNUChessControler* pGNU1 = new GNUChessControler();
    GNUChessControler* pGNU2 = new GNUChessControler();

    Controler<ChessBoard>* pKC1 = pGNU1;
    Controler<ChessBoard>* pKC2 = pGNU2;
    //Controler<ChessBoard>* pKC2 = new KeyboardControler();
    ConsoleChessDisplay display;

    display.setBoard(g.getBoard());

    statusNotifier.addListener(&display);

    pGNU1->start();
    pGNU2->start();

    g.addControler(pKC1);
    g.addControler(pKC2);

    std::cout << "g.play() : " << g.play() << std::endl;

    delete pKC1;
    delete pKC2;
    return 0;
}
*/

#include "UI/GameWidget.hpp"

#include "GameLauncher.hpp"

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    GameWidget w;

    w.show();
    a.exec();

    return 0;
}
